#=======================================================================
# Basic C++: Default definitions for makefiles
#-----------------------------------------------------------------------
# Jean-Paul Rigault --- Copyright 2003
# $Id: default.mk,v 1.1.1.1 2004/11/01 13:39:47 jpr Exp $
#=======================================================================

# Miscellaneous paths (do not forget that this file is included 
# two levels and sometimes three levels below) 

base = $(shell basename $(shell pwd))
INCL_DIR = ../../include/
STATEMENT_DIR = ../../Statements
INSTALL_DIR = $(STATEMENT_DIR)/$(base)
DEF_MK = ../../default.mk

# Well-known commands

INCL = -I$(INCL_DIR) 
DEFS = -D_DEBUG_
CXX_FLAGS =-g -ansi -Wall -Wold-style-cast -Woverloaded-virtual
CXX = g++ $(CXX_FLAGS) $(INCL) $(DEFS)

CFLAGS = -g -ansi -Wall
CC = gcc $(CFLAGS)

LINK_CXX = g++
LINK_CC = gcc

# Default rules

%.o :	%.c
	$(CC) -c $*.c

%.o :	%.cpp
	$(CXX) -c $*.cpp

%.exe : %.c
	$(CC) -o $@ $*.c

%.exe : %.cpp
	$(CXX) -o $@ $*.cpp


% :	%.o
	$(LINK.CC) -o $@ $*.o $(LIBS)

# Common targets
# Variables ALL must be defined in specific makefiles; in addition 
# INSTALL_SRCS may also be defined there

all :
	make $(ALL)
	-make extra_all

clean :
	-rm -f *.o a.out *.ps \#* *~
	-rm -f *.stackdump core
	-rm -f $(ALL)
	-make extra_clean

install :
	-mkdir $(STATEMENT_DIR); chmod a+rx $(STATEMENT_DIR)
	-mkdir $(INSTALL_DIR); chmod a+rx $(INSTALL_DIR)
	-cp $(INSTALL_SRCS) $(INSTALL_DIR)
	-cp Makefile.install $(INSTALL_DIR)/Makefile
	-make extra_install
	-chmod -R a+r $(INSTALL_DIR)




