//=======================================================================
// Basic C++: Index et rfrences croises : la classe Crossref
//-----------------------------------------------------------------------
// Jean-Paul Rigault --- Copyright 2003
// $Id: Crossref.cpp,v 1.1 2005/05/03 12:50:31 jpr Exp $
//=======================================================================

#include <algorithm>
using namespace std;

#include "stl_extensions.h"
using namespace JPR_STL_EXTENSIONS; 

#include "Index.h"
#include "Crossref.h"

// Une Crossref se construit  partir d'un Index. On utilise
// l'objet-fonction make_crossref sur chaque lment de l'Index.

Crossref::Crossref(const Index& index)
{
    for_each(index.begin(), index.end(), make_crossref(*this));
}


// Accesseur pour obtenir l'ensemble des mots d'une ligne

const set<string>& Crossref::operator[](int ln) const
{
    const_iterator it = _crossref.find(ln);
    if (it == _crossref.end())
        throw Not_Found();
    else
        return it->second;
}

// Oprateur d'affichage : on ne peut pas utiliser la fonction display()
// des collections, car set<> n'a pas d'oprateur <<

ostream& operator<<(ostream& os, const Crossref& cref)
{
    for (Crossref::const_iterator it = cref._crossref.begin();
         it != cref._crossref.end(); ++it)
    {
        os << it->first << " : ";
        display(os, it->second);
        os << '\n';
    }
    return os;            
}
       
// L'oprateur () fait le travail, lment de l'index par lment. Il
// roit donc une paire d type de celles de l'Index. Cet oprateur s'applique
//  chaque entre de l'index et l'inverse

void Crossref::make_crossref::operator()(pair<string, set<int> > p)
{
    for (set<int>::const_iterator it = p.second.begin(); it != p.second.end(); ++it)
    {
        _cr._crossref[*it].insert(p.first);
    }
}
