//=======================================================================
// Basic C++: a simple mathematical vector class
//      Test
//-----------------------------------------------------------------------
// Jean-Paul Rigault --- Copyright 2004
// $Id: main_MVector.cpp,v 1.1 2004/11/28 11:38:07 jpr Exp $
//=======================================================================

#include "common_defs.h"
#include "MVector.h"

int main()
{
    //cout << boolalpha;// Sets cout to print bool as true or false (not 1 and 0)

    MSG(Constructors);

    MVector mv0; 
    MVector mv1(5, 1.5);
    OUT(mv0);
    OUT(mv1);
    OUT(mv0 == mv1);

    MSG(Assignments);

    EXEC(mv0 = mv1);
    OUT(mv0);
    OUT(mv0 == mv1);
    OUT(mv1 += mv1);
    OUT(mv1 -= mv1);

    MSG (Scalar product and norm);

    OUT(mv0.norm());
    OUT(mv0 * mv0);

    MSG(Arithmetic operations);

    OUT(mv0 + mv0);
    OUT(mv0 - mv0);
    try
    {
        MVector mv2(10);
        OUT(mv0 + mv2);
    }
    catch (MVector::Bad_Dimensions)
    {
        cerr << "*** Bad dimensions" << endl;
    }    

    MSG(Subscript);

    EXEC(mv0[2] = 5.5);
    OUT(mv0[2]);
    try
    {
        OUT(mv0[107]);
    }
    catch (MVector::Out_Of_Bounds)
    {
        cerr << "*** Out of bounds" << endl;
    }

    const MVector cmv = mv1;
    OUT(cmv[2]);
    // cmv[2] = 3.5; DOES NOT COMPILE


    return 0;
}
