//=======================================================================
// Basic C++: procedural programming
//      A Fifo class: specification
//-----------------------------------------------------------------------
// Jean-Paul Rigault --- Copyright 2003
// $Id: Fifo.h,v 1.2 2004/11/01 15:19:04 jpr Exp $
//=======================================================================

#ifndef _FIFO_H_
#define _FIFO_H_

template <typename ELEM>
class Fifo
{
private:
    ELEM *_tab;
    int _nmax;
    int _geti;
    int _n;

public:
    // Exception classes
    class Full {};
    class Empty {};

    Fifo(int);
    void put(ELEM);
    ELEM get();
    bool is_full() const;
    bool is_empty() const;
};

// We suppose the "inclusion model" for templates
#include "Fifo.cpp"

#endif
