//--------------------------------------------------------------
//      A Stack class template Stack with exceptions
//              Specification
//      This version uses vector<> internally.   
//--------------------------------------------------------------
// Jean-Paul Rigault: Basic C++
// $Id: Stack.h,v 1.1 2004/11/06 19:37:45 jpr Exp $
//--------------------------------------------------------------

#ifndef _STACK_H_
#define _STACK_H_

#include <vector>
using namespace std;

template <typename ELEM>
class Stack
{
private:
    vector<ELEM> _tab;
    unsigned _top;

public:
    // Exception classes
    class Full {}; 
    class Empty {}; // not used...

    Stack();   
    void push(ELEM);
    ELEM pop();
    bool is_full() const; // always false
    bool is_empty() const;
};

// We suppose the "inclusion model" for templates
#include "Stack.cpp"

#endif
