//=======================================================================
// Basic C++: classe Fifo
//      Specification of class Fifo
//-----------------------------------------------------------------------
// Jean-Paul Rigault --- Copyright 2003
// $Id: Fifo.cpp,v 1.2 2004/11/01 15:19:04 jpr Exp $
//=======================================================================

#include "Fifo.h"

template <typename ELEM, int N>
Fifo<ELEM, N>::Fifo()
{
    _geti = 0;
    _n = 0;
}

template <typename ELEM, int N>
void Fifo<ELEM, N>::put(ELEM c)
{
    if (_n >= N) throw Full();
    int puti = (_geti + _n) % N;
    ++_n;
    _tab[puti] = c;
}

template <typename ELEM, int N>
ELEM Fifo<ELEM, N>::get()
{
    if (_n <= 0) throw Empty();
    ELEM c = _tab[_geti];
    _geti = (_geti + 1) % N;
    --_n;
    return c;
}

template <typename ELEM, int N>
bool Fifo<ELEM, N>::is_full() const
{
    return _n >= N;
}

template <typename ELEM, int N>
bool Fifo<ELEM, N>::is_empty() const
{
    return _n <= 0;
}
