//--------------------------------------------------------------
//      A Stack class template Stack with exceptions
//              Implementation
//--------------------------------------------------------------
// Jean-Paul Rigault: Basic C++
// $Id: Stack.cpp,v 1.2 2004/11/01 15:19:04 jpr Exp $
//--------------------------------------------------------------

#include "Stack.h"

template <typename ELEM, int N>
Stack<ELEM, N>::Stack() : _top(0)
{
}

template <typename ELEM, int N>
void Stack<ELEM, N>::push(ELEM c)
{
    if (_top >= N) throw Full();
    _tab[_top++] = c;
}

template <typename ELEM, int N>
ELEM Stack<ELEM, N>::pop()
{
    if (_top <= 0) throw Empty();
    return _tab[--_top];
}

template <typename ELEM, int N>
bool Stack<ELEM, N>::is_full() const
{
    return _top >= N;
}

template <typename ELEM, int N>
bool Stack<ELEM, N>::is_empty() const
{
    return _top <= 0;
}
